[PATCH 1/1] generic: add test for boundary in xfs_attr_shortform_verify

[Date Prev] [Date Next] [Thread Prev] [Thread Next] [Date Index] [Thread Index]



Add a regression test to check that the boundary test
for the fixed-offset parts of xfs_attr_sf_entry
in xfs_attr_shortform_verify is not off by one.

This can be shown by:

touch file
setfattr -n user.a file

With help from Zorro. Thanks very much.

Signed-off-by: Pavel Reichl <preichl@xxxxxxxxxx>
---
 tests/generic/609     | 64 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/609.out |  8 ++++++
 tests/generic/group   |  1 +
 3 files changed, 73 insertions(+)
 create mode 100755 tests/generic/609
 create mode 100644 tests/generic/609.out

diff --git a/tests/generic/609 b/tests/generic/609
new file mode 100755
index 00000000..fd632e86
--- /dev/null
+++ b/tests/generic/609
@@ -0,0 +1,64 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Red Hat, Inc. All Rights Reserved.
+#
+# FS QA Test 609
+#
+# Verify that metadata won't get corrupted when extended attribute
+# name of size one is set.
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_attrs
+
+TESTFILE="${SCRATCH_MNT}/testfile"
+
+echo "+ create scratch fs"
+_scratch_mkfs > /dev/null 2>&1
+
+echo "+ mount fs image"
+_scratch_mount
+
+echo "+ make test file"
+touch "${TESTFILE}"
+
+echo "+ set file attributes"
+"${SETFATTR_PROG}" -n user.a "${TESTFILE}"
+
+echo 3 > /proc/sys/vm/drop_caches
+sleep 3
+
+echo "+ get file attributes"
+"${GETFATTR_PROG}" --absolute-names -n user.a "${TESTFILE}" | grep "user.a"
+
+echo "+ umount fs image"
+umount "${SCRATCH_MNT}"
+
+status=0
+exit
diff --git a/tests/generic/609.out b/tests/generic/609.out
new file mode 100644
index 00000000..aab84553
--- /dev/null
+++ b/tests/generic/609.out
@@ -0,0 +1,8 @@
+QA output created by 609
++ create scratch fs
++ mount fs image
++ make test file
++ set file attributes
++ get file attributes
+user.a=""
++ umount fs image
diff --git a/tests/generic/group b/tests/generic/group
index aa969bcb..66bfb9dd 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -611,3 +611,4 @@
 606 auto attr quick dax
 607 auto attr quick dax
 608 auto attr quick dax
+609 auto attr
-- 
2.26.2




[Index of Archives]     [Linux Filesystems Development]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux